VERSION 5.00
Object = "{2EC9A174-C7CA-4DF8-ABA0-47095DA87277}#1.0#0"; "TAPIExCt.dll"
Begin VB.Form Form1 
   Caption         =   "Three Way Call Flash Demo"
   ClientHeight    =   5025
   ClientLeft      =   6780
   ClientTop       =   4800
   ClientWidth     =   6600
   LinkTopic       =   "Form1"
   ScaleHeight     =   5025
   ScaleWidth      =   6600
   Begin VB.Frame Frame2 
      Caption         =   "Device"
      Height          =   735
      Left            =   120
      TabIndex        =   9
      Top             =   120
      Width           =   4335
      Begin VB.ComboBox CbLines 
         Height          =   315
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   10
         Top             =   240
         Width           =   3495
      End
   End
   Begin VB.Frame Frame1 
      Height          =   1695
      Left            =   120
      TabIndex        =   2
      Top             =   960
      Width           =   5415
      Begin VB.CommandButton BnThreeWay 
         Caption         =   "ThreeWay"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   400
         Left            =   240
         TabIndex        =   8
         Top             =   1200
         Width           =   1455
      End
      Begin VB.TextBox Txt2ndPhN 
         Height          =   285
         Left            =   1920
         TabIndex        =   7
         Tag             =   "0"
         Text            =   "<Enter 2nd Ph. Number>"
         Top             =   840
         Width           =   1815
      End
      Begin VB.TextBox Txt1StPhN 
         Height          =   315
         Left            =   1920
         TabIndex        =   6
         Tag             =   "0"
         Text            =   "<Enter 1st Ph. Number>"
         Top             =   360
         Width           =   1815
      End
      Begin VB.CommandButton BnDial2 
         Caption         =   "Dial 2nd Call"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   405
         Left            =   240
         TabIndex        =   5
         Top             =   720
         Width           =   1455
      End
      Begin VB.CommandButton BnDial1 
         Caption         =   "Dial 1st Call"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   405
         Left            =   240
         TabIndex        =   4
         Top             =   240
         Width           =   1455
      End
      Begin VB.CommandButton BnDropCall 
         Caption         =   "Drop Call"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   400
         Left            =   3960
         TabIndex        =   3
         Top             =   240
         Width           =   1335
      End
   End
   Begin VB.TextBox TxtLog 
      Height          =   1935
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Top             =   2880
      Width           =   6255
   End
   Begin TAPIEXLibCtl.TAPIExCtl mTAPIEx 
      Height          =   450
      Left            =   5160
      OleObjectBlob   =   "Form1.frx":0000
      TabIndex        =   11
      Top             =   480
      Width           =   450
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'####################################################################################
'# Program name: Three Way Call Hook-Flash demo                                     #
'#                                                                                  #
'# Version: v1.0                                                                    #
'#                                                                                  #
'# Date: July 20th 2004                                                             #
'#                                                                                  #
'# Requirements:                                                                    #
'#    VOICE modem or TAPI compliant telephony device                                #
'#    Phone line with 3-way calling                                                 #
'#                                                                                  #
'# Operating System: Windows 98, Windows ME, Windows NT 4, Windows 2000, Windows XP #
'#                                                                                  #
'# Note: Under Windows NT 4 voice modems may not supported because of the lack of a #
'# voice capable TAPI universal modem driver.                                       #
'#                                                                                  #
'# Program Purpose: To demonstrate how to add telephony functions to your application#
'# using the TAPIEx ActiveX control.                                                #
'#                                                                                  #
'####################################################################################
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Dim currCall As ITAPICall


Private Sub BnDial1_Click()

Dim deviceID As Long
Dim currLine As ITAPILine

deviceID = CbLines.ItemData(CbLines.ListIndex)
Set currLine = mTAPIEx.GetLineFromDeviceID(deviceID)
If currLine.Open() Then  ' Open the device
  Set currCall = currLine.MakeCall(Txt1StPhN.Text) 'make the first call
  BnDial1.Enabled = False
End If
End Sub

Private Sub BnDial2_Click()
 ' make the second call here
  currCall.GenerateDTMF "!" ' send the hook-flash command
  Sleep (1500)              'wait 1.5 second for the dialtone
  currCall.GenerateDTMF Txt2ndPhN.Text  ' now Dial the second phone number
  BnDial2.Enabled = False
  BnThreeWay.Enabled = True
End Sub

Private Sub BnDropCall_Click()
  currCall.Drop
  BnDial1.Enabled = True
  BnThreeWay.Enabled = False
End Sub


Private Sub BnThreeWay_Click()
 currCall.GenerateDTMF "!"  'flash again
End Sub

Private Sub CbLines_Click()
 '
 BnDial1.Enabled = CbLines.ListIndex >= 0
End Sub

Private Sub Form_Load()
 Dim line As ITAPILine
 mTAPIEx.Initialize
  For Each line In mTAPIEx.Lines  'enumerate the line devices
   If (line.Caps.Line_Features And LINE_FEATURE_MAKECALL) > 0 Then
      CbLines.AddItem line.DeviceName
      CbLines.ItemData(CbLines.ListCount - 1) = line.deviceID
   End If
  Next
End Sub

Private Sub mTAPIEx_OnConnected(ByVal m_Call As TAPIEXLibCtl.ITAPICall, ByVal ConnectedMode As TAPIEXLibCtl.LINECONNECTEDMODE)
 BnDial2.Enabled = True
 BnDropCall.Enabled = True
End Sub

Private Sub mTAPIEx_OnDebug(ByVal msg As String)
  TxtLog.Text = TxtLog.Text & msg & vbCrLf
End Sub


Private Sub mTAPIEx_OnDisConnected(ByVal m_Call As TAPIEXLibCtl.ITAPICall, ByVal DisconnectedMode As TAPIEXLibCtl.LINEDISCONNECTMODE)
 BnDial2.Enabled = False
 BnDropCall.Enabled = False
 BnThreeWay.Enabled = False
End Sub

Private Sub Txt1StPhN_Click()
 If Txt1StPhN.Tag <> 1 Then
  Txt1StPhN.Text = ""
  Txt1StPhN.Tag = 1
 End If
End Sub

Private Sub Txt1StPhN_KeyDown(KeyCode As Integer, Shift As Integer)
 Txt1StPhN_Click
End Sub



Private Sub Txt2ndPhN_Click()
 If Txt2ndPhN.Tag <> 1 Then
  Txt2ndPhN.Text = ""
  Txt2ndPhN.Tag = 1
 End If
End Sub

Private Sub Txt2ndPhN_KeyDown(KeyCode As Integer, Shift As Integer)
 Txt2ndPhN_Click
End Sub
